/* for UY0LL's DX-Cluster Voice System
  uy0ll@uy0ll.ampr.org , uy0ll@buscom.kharkov.ua */
#include <stdio.h>
#include <time.h>
#include <sys/file.h>
#include <sys/fcntl.h>

#define PH_ZERO         0
#define PH_ONE		1
#define PH_TWO		2
#define PH_THREE	3
#define PH_FOUR		4
#define PH_FIVE		5
#define PH_SIX		6
#define PH_SEVEN	7
#define PH_EIGHT	8
#define PH_NINE		9
#define PH_TEN		10
#define PH_ELEVEN	11
#define PH_TWELVE	12
#define PH_THIRTEEN	13
#define PH_FOURTEEN	14
#define PH_FIFTEEN	15
#define PH_SIXTEEN	16
#define PH_SEVENTEEN	17
#define PH_EIGHTEEN	18
#define PH_NINETEEN	19
#define PH_TWENTY	20
#define PH_THIRTY	30
#define PH_FORTY	40
#define PH_FIFTY	50
#define PH_SIXTY	60
#define PH_SEVENTY	270
#define PH_EIGHTY	280
#define PH_NINETY	290
#define PH_ONEH		100
#define PH_TWOH         200
#define PH_THREEH	300
#define PH_FOURH	400
#define PH_FIVEH	500
#define PH_SIXH		600
#define PH_SEVENH	700
#define PH_EIGHTH	800
#define PH_NINEH	900
#define PH_THOUS	1000
#define PH_MHZ		274
#define PH_KHZ		275
#define PH_GHZ          289
#define PH_AND		276
#define PH_DES		277
#define PH_FREQ		272
#define PH_MSG		278
#define PAUSE           273
#define PH_STROC	'/'
#define PH_TIRE		'-'
#define WSEM		'@'
#define A	'A'
#define B	'B'
#define C	'C'
#define D	'D'
#define E	'E'
#define F	'F'
#define G	'G'
#define I	'I'
#define H	'H'
#define J	'J'
#define K	'K'
#define L	'L'
#define M	'M'
#define N	'N'
#define O	'O'
#define P	'P'
#define Q	'Q'
#define R	'R'
#define S	'S'
#define T	'T'
#define U	'U'
#define V	'V'
#define W	'W'
#define X	'X'
#define Y	'Y'
#define Z	'Z'
#define TADA    777

void saynumber(), saydigit(), sayphrase(), sayfile(), sayclose();

void main()
{
char ch,digi[85];
int number,i=0,des,m,leadzero=0;
des=0;
while(( ch=getchar() ) != EOF )
	{
	if(ch != '\n' && ch != ' ' && ch != '.')
		{
		digi[i]	=ch;
		i++;
		continue;
		}
	if(des ==  2)
	{
	des = 1;
	goto clear;
	}
	if(ch == '.')
	des=2;
	if(digi[0] == '@')
	{
	sayphrase( WSEM );
	des=0;
	goto clear;
	}
	if(digi[0] == '#')
	{
	sayphrase( TADA );
	goto clear;
	}
	if(digi[0] == '$')
		{
		sayphrase( PH_MSG );
		goto clear;
		}
	for(m=0;m<i;m++)
	if(isalpha(digi[m]) == 1)
		{
		for(m=0;m<i;m++)
			{
			if(isdigit( digi[m] ) == 1)
				{ 
				number=digi[m]-0x30;
				sayphrase(number);
				}
			else
				{
				if(digi[m] != '/' && digi[m] != '-')
				digi[m]= digi[m] & 0xdf ;
				sayphrase( digi[m]);
				}
			}
		goto clear;
		}
digit:  if(isdigit(digi[0]) == 1)
	{
		if(des == 0)
		{
		sayphrase(PH_FREQ);
		sayphrase(PAUSE);
		leadzero = 0;
		des=1;
		}
		number=atoi(digi);
		saynumber( number, leadzero );
		leadzero=1;
	}
clear:
	sayclose();
	for(i=0;i<85;i++)
	digi[i]=0;
	i=0;
	}
exit(0);
}

void
saynumber( n, leadingzero )
int n,leadingzero;
    {
int ones, tens,hundr,thouth,tenthouth;
ones= n%10;
tenthouth=n/10000;
thouth=(n-tenthouth*10000)/1000;
hundr=abs(n-thouth*1000-tenthouth*10000)/100;
tens=(n-hundr*100-thouth*1000-tenthouth*10000)/10;

if( thouth != 0 || tenthouth != 0)
{
saytens ( thouth,tenthouth,0 );
sayphrase(PH_GHZ);
}
    switch ( hundr )
	{
	case 0:
	 {
	if(leadingzero == 1)
		{
		sayphrase(PH_ZERO);
		if(tens == 0)
		sayphrase(PH_ZERO);
		}
	saytens(ones,tens,leadingzero);
	break;
	 }

	case 1:
	sayphrase(PH_ONEH);
		saytens(ones,tens,leadingzero);
	break;

	case 2:
	sayphrase( PH_TWOH );
	    saytens( ones,tens,leadingzero );
	break;

	case 3:
	sayphrase( PH_THREEH );
	    saytens( ones,tens,leadingzero );
	break;

	case 4:
	sayphrase( PH_FOURH );
	    saytens( ones,tens,leadingzero );
	break;

	case 5:
	sayphrase( PH_FIVEH );
	    saytens( ones,tens,leadingzero );
	break;

	case 6:
	sayphrase( PH_SIXH );
	saytens ( ones,tens,leadingzero );
	break;

	case 7:
	sayphrase( PH_SEVENH );
	saytens ( ones,tens,leadingzero );
	break;

	case 8:
	sayphrase(PH_EIGHTH );
	saytens ( ones,tens,leadingzero );
	break;

	case 9:
	sayphrase (PH_NINEH );
	saytens (ones,tens,leadingzero );
	break;

	default:
/*	(void) fprintf( stderr, "Shouldn't happen.\n" );
	exit( 1 ); */
	break;
	}
    }

saytens ( ones,tens,leadingzero )
int ones,tens,leadingzero;
{
if(tens != 0 || ones != 0)
    {
    switch ( tens )
	{
	case 0:
	 {
	if (leadingzero )
	if (ones == 0 )
	sayphrase ( PH_ZERO); 
	saydigit(ones);
	break;
	 }

	case 1:
	switch(ones)
		{
	    case 0:
	    sayphrase( PH_TEN );
	    break;

	    case 1:
	    sayphrase( PH_ELEVEN );
	    break;

	    case 2:
	    sayphrase( PH_TWELVE );
	    break;

	    case 3:
	    sayphrase( PH_THIRTEEN );
	    break;

	    case 4:
	    sayphrase( PH_FOURTEEN );
	    break;

	    case 5:
	    sayphrase( PH_FIFTEEN );
	    break;

	    case 6:
	    sayphrase( PH_SIXTEEN );
	    break;

	    case 7:
	    sayphrase( PH_SEVENTEEN );
	    break;

	    case 8:
	    sayphrase( PH_EIGHTEEN );
	    break;

	    case 9:
	    sayphrase( PH_NINETEEN );
	    break;

	    default:
		if(ones == 0)
		break;
/*	    (void) fprintf( stderr, "Shouldn't happen.\n" );
	    exit( 1 ); */
		break;
	    }
	break;

	case 2:
	sayphrase( PH_TWENTY );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 3:
	sayphrase( PH_THIRTY );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 4:
	sayphrase( PH_FORTY );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 5:
	sayphrase( PH_FIFTY );
	if ( ones != 0 )
	    saydigit( ones );
	break;

	case 6:
	sayphrase( PH_SIXTY );
	if ( ones != 0)
	saydigit ( ones );
	break;

	case 7:
	sayphrase( PH_SEVENTY );
	if (ones != 0)
	saydigit ( ones );
	break;

	case 8:
	sayphrase(PH_EIGHTY );
	if (ones != 0)
	saydigit ( ones );
	break;

	case 9:
	sayphrase (PH_NINETY );
	if (ones != 0)
	saydigit (ones );
	break;

	default:
/*	(void) fprintf( stderr, "Shouldn't happen.\n" );
	exit( 1 ); */
	break;
	}
    }
}
void
saydigit( n )
int n;
    {
    switch ( n )
	{
	case 0:
	break;

	case 1:
	sayphrase( PH_ONE );
	break;

	case 2:
	sayphrase( PH_TWO );
	break;

	case 3:
	sayphrase( PH_THREE );
	break;

	case 4:
	sayphrase( PH_FOUR );
	break;

	case 5:
	sayphrase( PH_FIVE );
	break;

	case 6:
	sayphrase( PH_SIX );
	break;

	case 7:
	sayphrase( PH_SEVEN );
	break;

	case 8:
	sayphrase( PH_EIGHT );
	break;

	case 9:
	sayphrase( PH_NINE );
	break;

	default:
/*	(void) fprintf( stderr, "Shouldn't happen.\n" );
	exit( 1 ); */
	break;
	}
    }

void
sayphrase( phrase )
int phrase;
    {
    switch ( phrase )
	{
	case PH_ZERO:
	sayfile( "0.au" );
	break;

	case PH_ONE:
	sayfile( "1.au" );
	break;

	case PH_TWO:
	sayfile( "2.au" );
	break;

	case PH_THREE:
	sayfile( "3.au" );
	break;

	case PH_FOUR:
	sayfile( "4.au" );
	break;

	case PH_FIVE:
	sayfile( "5.au" );
	break;

	case PH_SIX:
	sayfile( "6.au" );
	break;

	case PH_SEVEN:
	sayfile( "7.au" );
	break;

	case PH_EIGHT:
	sayfile( "8.au" );
	break;

	case PH_NINE:
	sayfile( "9.au" );
	break;

	case PH_TEN:
	sayfile( "10.au" );
	break;

	case PH_ELEVEN:
	sayfile( "11.au" );
	break;

	case PH_TWELVE:
	sayfile( "12.au" );
	break;

	case PH_THIRTEEN:
	sayfile( "13.au" );
	break;

	case PH_FOURTEEN:
	sayfile( "14.au" );
	break;

	case PH_FIFTEEN:
	sayfile( "15.au" );
	break;

	case PH_SIXTEEN:
	sayfile( "16.au" );
	break;

	case PH_SEVENTEEN:
	sayfile( "17.au" );
	break;

	case PH_EIGHTEEN:
	sayfile( "18.au" );
	break;

	case PH_NINETEEN:
	sayfile( "19.au" );
	break;

	case PH_TWENTY:
	sayfile( "20.au" );
	break;

	case PH_THIRTY:
	sayfile( "30.au" );
	break;

	case PH_FORTY:
	sayfile( "40.au" );
	break;

	case PH_FIFTY:
	sayfile( "50.au" );
	break;
	
	case PH_SIXTY:
	sayfile( "60.au" );
	break;

	case PH_SEVENTY:
	sayfile( "70.au" );
	break;

	case PH_EIGHTY:
	sayfile( "80.au" );
	break;
	
	case PH_NINETY:
	sayfile( "90.au" );
	break;

	case PH_ONEH:
	sayfile( "100.au" );
	break;

	case PH_TWOH:
	sayfile( "200.au" );
	break;

	case PH_THREEH:
	sayfile( "300.au" );
	break;

	case PH_FOURH:
	sayfile( "400.au" );
	break;

	case PH_FIVEH:
	sayfile( "500.au" );
	break;

	case PH_SIXH:
	sayfile( "600.au" );
	break;

	case PH_SEVENH:
	sayfile( "700.au" );
	break;

	case PH_EIGHTH:
	sayfile( "800.au" );
	break;

	case PH_NINEH:
	sayfile( "900.au" );
	break;

	case PH_THOUS:
	sayfile( "1000.au" );
	break;

	case PH_MHZ:
	sayfile( "mhz.au" );
	break;

	case PH_KHZ:
	sayfile( "khz.au" );
	break;

	case PH_GHZ:
	sayfile( "ghz.au" );
	break;

	case PH_FREQ:
	sayfile( "freq.au" );
	break;

	case PH_MSG:
	sayfile( "msg.au" );
	break;

	case PH_DES:
	sayfile( "des.au" );
	break;

	case PH_AND:
	sayfile( "and.au" );
	break;

	case A:
	sayfile ( "a.au" );
	break;

	case B:
	sayfile ( "b.au" );
	break;

	case C:
	sayfile ( "c.au" );
	break;

	case D:
	sayfile ( "d.au" );
	break;

	case E:
	sayfile ( "e.au" );
	break;

	case F:
	sayfile ("f.au" );
	break;

	case G:
	sayfile ("g.au");
	break;

	case I:
	sayfile ("i.au");
	break;

	case H:
	sayfile ("h.au");
	break;

	case J:
	sayfile ("j.au");
	break;

	case K:
	sayfile ("k.au");
	break;

	case L:
	sayfile ("l.au");
	break;

	case M:
	sayfile ("m.au");
	break;

	case N:
	sayfile ("n.au");
	break;

	case O:
	sayfile ("o.au");
	break;

	case P:
	sayfile ("p.au");
	break;

	case Q:
	sayfile ("q.au");
	break;

	case R:
	sayfile ("r.au");
	break;

	case S:
	sayfile ("s.au");
	break;

	case T:
	sayfile ("t.au");
	break;

	case U:
	sayfile ("u.au");
	break;

	case V:
	sayfile ("v.au");
	break;

	case W:
	sayfile ("w.au");
	break;
	
	case X:
	sayfile ("x.au");
	break;

	case Y:
	sayfile ("y.au");
	break;

	case Z:
	sayfile ("z.au");
	break;

	case PAUSE:
	sayfile ("pause.au");
	break;

	case TADA:
	sayfile ("tada.au");
	sayfile ("pause.au");
	break;

	case PH_STROC:
	sayfile ("stroc.au");
	break;

	case PH_TIRE:
	sayfile ("tire.au");
	break;

	case WSEM:
	sayfile("pause.au");
	sayfile("wsem.au");
	break;

	default:
/*	(void) fprintf( stderr, "Shouldn't happen.\n" ); */
/*	exit( 1 ); */
	break;
	}
    }

int audiofd = -1;

void
sayfile( filename )
char *filename;
    {
    int filefd;
    int r, w;
    unsigned char buf[1024];
    char pathname[200];

    if ( audiofd == -1 )
	{
	audiofd = open( "/dev/dsp", O_WRONLY | O_NDELAY );
	if ( audiofd < 0 )
	    {
	    perror( "opening /dev/dsp" );
	    exit( 1 );
	    }
	}

    (void) sprintf( pathname, "%s/%s", SOUND_DIR, filename );
    filefd = open( pathname, O_RDONLY );
    if ( filefd < 0 )
	{
	perror( "opening audio file" );
	exit( 1 );
	}

    for ( ; ; )
	{
	r = read( filefd, buf, sizeof(buf) );
	if ( r < 0 )
	    {
	    perror( "reading from audio file" );
	    exit( 1 );
	    }
	if ( r == 0 )
	    break;

	for ( ; ; )
	    {
	    w = write( audiofd, buf, r );
	    if ( w < 0 )
		{
		perror( "writing to audio device" );
		exit( 1 );
		}
	    if ( w != 0 )
		break;
	    usleep( 1000 );
	    }
	if ( w != r )
	    {
	    (void) fprintf( stderr, "read returned %d, write returned %d\n", r, w );
	    exit( 1 );
	    }
	}
    close( filefd );
    }

void
sayclose( )
    {
    if ( audiofd != -1 )
	close( audiofd );
    audiofd = -1;
    }
